#include <bits/stdc++.h>

using namespace std;

int main()
{
    int h,n;
    cin>>h>>n;
    vector<vector<int> > vp(h,vector<int> (n));
    for(int i=0;i<h;i++){
        for(int j=0;j<n;j++){
            cin>> vp[i][j];
        }
    }
    vector<int> a (n,1);
    vector<int> b (n);
    for(int i=0;i<h;i++){
        int lstValid = -2;int s=0;

        for(int j=0;j<n;j++){

            if(vp[i][j]==1){
                if(lstValid==-2){
                    b[j]=a[j]+s;
                }
                if(lstValid==j-1){
                    b[j]=a[j];
                }
                else{
                    b[j]=s/2+a[j];
                    b[lstValid]+=(s+1)/2;
                }
                s=0;
                lstValid=j;
            }
            else{
                s+=a[j];
            }

        }
        b[lstValid]+=s;
        a=b;
    }
    for(int j=0;j<n;j++){
        cout<< a[j] << ' ';
    }
    cout <<  endl;
    return 0;
}